#!/usr/bin/python

# This python module will send a mail message to a zope instance that has the relevent
# ZMailIn client present.

# $Id: zopeMailIn.py,v 1.9 2001/02/20 16:36:24 andyd Exp $

__version__='$Revision: 1.9 $'[11:-2]  

import sys, zopeMailInConf, urllib
import rfc822, StringIO, string

def GetLocationHTTP(host, emailaddress):
        # Attempt to get the location of the ZMailIn client for the given email address
        try:
                returned = urllib.urlopen(host, urllib.urlencode({'email_address':emailaddress})).read()
        except IOError,e:
                print "ZMailIn Error: Problem Connecting to server",e
                sys.exit(73)
        return returned

def _make_url(host=zopeMailInConf.host, path=''):
        user_and_pass=''
        
        if zopeMailInConf.username and zopeMailInConf.password:
                user_and_pass="%s:%s@"%(zopeMailInConf.username,zopeMailInConf.password)
                
        return host[:7] + user_and_pass + host[7:] + path

if __name__ == '__main__':
        # This gets called by the MTA when a new message arrives.
        # The mail message file gets passed in on the stdin
        
        f = sys.stdin   # First get a handle on the message file
        messageText = f.read()
        
        url = ''
        if len(sys.argv)>1:
                url = sys.argv[1]
        
        if not url:
                # get a url
                mf = rfc822.Message(StringIO.StringIO(messageText))
                messageTo = mf.get('envelope-to',mf.get('to',''))
                if not messageTo:
                        print "ZMailIn Error: No 'envelope-to' or 'to' header in message"
                        sys.exit(1)
                        
                host = _make_url(path='getZMailInClientLocation')

                # Try to get the exact email address
                url = GetLocationHTTP(host, messageTo)
                
                if url[:4]=='FAIL':
                        print "ZMailIn Error:",url
                        sys.exit(1)
                
                if url=='Not Found':
                        # We didn't get the exact email address so try for a domain match only
                        domain = messageTo[string.rfind(messageTo,'@'):]
                        url = GetLocationHTTP(host, domain)
                
                if url=='Not Found' or '\n' in url:
                        print "ZMailIn Error: ZMailIn Client does not exist"
                        sys.exit(1)
                        
                url = _make_url(url)

        if url:
                
                url = url + '/postZMailMessage'
                try:
                        result = urllib.urlopen(url, urllib.urlencode({'file':messageText})).read()
                except (IOError,EOFError),e:
                        print "ZMailIn Error: Problem Connecting to server",e
                        sys.exit(73)
                
                # if the ZMailIn Client's method returned anything, then 'something bad' happened.
                if result:
                        print result
                        sys.exit(1)
                        
                sys.exit(0)

        print "ZMailIn Error: No ZMailIn Client URL found or specified."
        sys.exit(1)
        
        
